package ru.ispras.kmb.vedomost;

import static org.junit.Assert.assertEquals;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;

import org.junit.Test;

import ru.ispras.kmb.vedomost.PersonTest.VedomostStub.AddParams;

public class PersonTest
{
    public class VedomostStub implements Vedomost
    {
        public class AddParams
        {
            public AddParams(int day, String name)
            {
                this.day = day;
                this.name = name;
            }
            private int day;
            private String name;
            public int getDay()
            {
                return day;
            }
            public String getName()
            {
                return name;
            }
        }
        private int count;
        private List<AddParams> addParams = new ArrayList<>();

        @Override
        public void add( int day, String name ) throws IllegalDayException
        {
            addParams.add( new AddParams( day, name ) );
        }
        
        public List<AddParams> getAddCalls()
        {
            return Collections.unmodifiableList( addParams );
        }
        
        @Override
        public List<Integer> get( String name )
        {
            // TODO Auto-generated method stub
            return null;
        }

        @Override
        public Set<String> get( int day )
        {
            // TODO Auto-generated method stub
            return null;
        }

    }

    @Test
    public void test1() throws IllegalDayException
    {
        Person p = new Person( VedomostTest.IVANOV );
        VedomostStub v = new VedomostStub();
        
        p.add( v, 1 );
        
        // TODO: Проверить, что был вызов v.add( 1, VedomostTest.IVANOV )
        List<AddParams> addCalls = v.getAddCalls();
        assertEquals( 1, addCalls.size() );
        assertEquals( 1, addCalls.get(0).getDay() );
    }

    @Test
    public void test2() throws IllegalDayException
    {
        Person p = new Person( VedomostTest.IVANOV );
        VedomostStub v = new VedomostStub();
        
        p.add( v, 2 );
        
        // TODO: Проверить, что был вызов v.add( 2, VedomostTest.IVANOV )
        List<AddParams> addCalls = v.getAddCalls();
        assertEquals( 1, addCalls.size() );
        assertEquals( 2, addCalls.get(0).getDay() );
    }

    @Test
    public void test12() throws IllegalDayException
    {
        Person p = new Person( VedomostTest.IVANOV );
        VedomostStub v = new VedomostStub();
        
        p.add( v, 1 );
        p.add( v, 2 );
        
        // TODO: Проверить, что был вызов v.add( 2, VedomostTest.IVANOV )
        List<AddParams> addCalls = v.getAddCalls();
        assertEquals( 2, addCalls.size() );
        assertEquals( 1, addCalls.get(0).getDay() );
        assertEquals( 2, addCalls.get(1).getDay() );
    }
}
